"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var util_1 = require("../util");
var NsisComposer = /** @class */ (function () {
    function NsisComposer(options) {
        this.options = options;
        if (!this.options.appName) {
            this.options.appName = 'NO_APPNAME';
        }
        if (!this.options.companyName) {
            this.options.companyName = 'NO_COMPANYNAME';
        }
        if (!this.options.description) {
            this.options.description = 'NO_DESCRIPTION';
        }
        if (!this.options.version) {
            this.options.version = 'NO_VERSION';
        }
        if (!this.options.copyright) {
            this.options.copyright = 'NO_COPYRIGHT';
        }
        this.options.compression = this.options.compression || 'lzma';
        this.options.solid = this.options.solid ? true : false;
        this.options.languages = this.options.languages && this.options.languages.length > 0 ? this.options.languages : ['English'];
        this.fixedVersion = util_1.fixWindowsVersion(this.options.version);
    }
    NsisComposer.prototype.getUninstallerName = function () {
        return 'Uninstall';
    };
    NsisComposer.prototype.make = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j;
            return __generator(this, function (_k) {
                switch (_k.label) {
                    case 0:
                        _a = "\n################################################################################\n#\n# Generated by nsis-gen.\n#\n################################################################################\n\n################################################################################\n#\n# Includes\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeIncludes()];
                    case 1:
                        _b = _a + (_k.sent()) + "\n\n################################################################################\n#\n# Strings\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeStrings()];
                    case 2:
                        _c = _b + (_k.sent()) + "\n\n################################################################################\n#\n# General\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeGeneral()];
                    case 3:
                        _d = _c + (_k.sent()) + "\n\n################################################################################\n#\n# Variables\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeVariables()];
                    case 4:
                        _e = _d + (_k.sent()) + "\n\n################################################################################\n#\n# Modern UI\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeModernUI()];
                    case 5:
                        _f = _e + (_k.sent()) + "\n\n################################################################################\n#\n# Versioning\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeVersioning()];
                    case 6:
                        _g = _f + (_k.sent()) + "\n\n################################################################################\n#\n# Hooks\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeHooks()];
                    case 7:
                        _h = _g + (_k.sent()) + "\n\n################################################################################\n#\n# Install\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeInstallSection()];
                    case 8:
                        _j = _h + (_k.sent()) + "\n\n################################################################################\n#\n# Uninstall\n#\n################################################################################\n";
                        return [4 /*yield*/, this.makeUninstallSection()];
                    case 9: return [2 /*return*/, _j + (_k.sent())];
                }
            });
        });
    };
    NsisComposer.prototype.makeIncludes = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "\n!include \"common.nsh\"\n"];
            });
        });
    };
    NsisComposer.prototype.makeStrings = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "\n\n!define _APPNAME \"" + this.options.appName + "\"\n!define _UNINSTNAME \"" + this.getUninstallerName() + "\"\n!define _COMPANYNAME \"" + this.options.companyName + "\"\n!define _DESCRIPTION \"" + this.options.description + "\"\n!define _VERSION \"" + this.fixedVersion + "\"\n!define _COPYRIGHT \"" + this.options.copyright + "\"\n!define _OUTPUT \"" + path_1.win32.normalize(path_1.resolve(this.options.output)) + "\"\n\n" + this.options.languages.map(function (language) {
                        return NsisComposer.STRINGS[language] ? NsisComposer.STRINGS[language] : '';
                    })];
            });
        });
    };
    NsisComposer.prototype.makeGeneral = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = "\nUnicode true\n\nName \"${_APPNAME}\"\nCaption \"${_APPNAME}\"\nBrandingText \"${_APPNAME} ${_VERSION}\"\n" + (this.options.icon
                            ? "Icon \"" + path_1.win32.normalize(path_1.resolve(this.options.icon)) + "\""
                            : '') + "\n" + (this.options.unIcon
                            ? "UninstallIcon \"" + path_1.win32.normalize(path_1.resolve(this.options.unIcon)) + "\""
                            : '') + "\n\nSetCompressor " + (this.options.solid ? '/SOLID' : '') + " " + this.options.compression + "\n\nInstallDir \"" + this.options.installDirectory + "\"\nInstallDirRegKey HKCU \"Software\\${_APPNAME}\" \"InstallDir\"\n\nRequestExecutionLevel user\nXPStyle on\n\n# General - OutFile\n";
                        return [4 /*yield*/, this.makeGeneralOutFile()];
                    case 1: return [2 /*return*/, _a + (_b.sent()) + "\n\n"];
                }
            });
        });
    };
    NsisComposer.prototype.makeGeneralOutFile = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "OutFile \"${_OUTPUT}\""];
            });
        });
    };
    NsisComposer.prototype.makeVariables = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "\n\nVar StartMenuFolder\n"];
            });
        });
    };
    NsisComposer.prototype.makeModernUI = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = "\n\n!include \"MUI2.nsh\"\n\n!define MUI_STARTMENUPAGE_REGISTRY_ROOT \"HKCU\"\n!define MUI_STARTMENUPAGE_REGISTRY_KEY \"Software\\${_APPNAME}\"\n!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME \"StartMenuFolder\"\n\n# Modern UI - Install Wizard\n";
                        return [4 /*yield*/, this.makeModernUIInstallWizard()];
                    case 1:
                        _b = _a + (_c.sent()) + "\n\n# Modern UI - Uninstall Wizard\n";
                        return [4 /*yield*/, this.makeModernUIUnInstallWizard()];
                    case 2: return [2 /*return*/, _b + (_c.sent()) + "\n\n" + this.options.languages.map(function (language) {
                            return "!insertmacro MUI_LANGUAGE \"" + language + "\"";
                        }).join('\n') + "\n\n" + (this.options.languages.length > 1
                            ? "!insertmacro MUI_RESERVEFILE_LANGDLL"
                            : '')];
                }
            });
        });
    };
    NsisComposer.prototype.makeModernUIInstallWizard = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "\nFunction CreateDesktopShortcut\n    CreateShortcut \"$DESKTOP\\${_APPNAME}.lnk\" \"$INSTDIR\\${_APPNAME}.exe\"\nFunctionEnd\n\n!define MUI_FINISHPAGE_SHOWREADME \"\"\n!define MUI_FINISHPAGE_SHOWREADME_TEXT \"$(CREATE_DESKTOP_SHORTCUT)\"\n!define MUI_FINISHPAGE_SHOWREADME_FUNCTION CreateDesktopShortcut\n\n!define MUI_FINISHPAGE_RUN \"$INSTDIR\\${_APPNAME}.exe\"\n\n!insertmacro MUI_PAGE_WELCOME\n!insertmacro MUI_PAGE_DIRECTORY\n!insertmacro MUI_PAGE_STARTMENU \"Application\" $StartMenuFolder\n!insertmacro MUI_PAGE_INSTFILES\n!insertmacro MUI_PAGE_FINISH\n        "];
            });
        });
    };
    NsisComposer.prototype.makeModernUIUnInstallWizard = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "\n!insertmacro MUI_UNPAGE_WELCOME\n!insertmacro MUI_UNPAGE_CONFIRM\n!insertmacro MUI_UNPAGE_INSTFILES\n!insertmacro MUI_UNPAGE_FINISH\n        "];
            });
        });
    };
    NsisComposer.prototype.makeVersioning = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "\n\nVIProductVersion \"${_VERSION}\"\nVIAddVersionKey /LANG=0 \"ProductName\" \"${_APPNAME}\"\nVIAddVersionKey /LANG=0 \"CompanyName\" \"${_COMPANYNAME}\"\nVIAddVersionKey /LANG=0 \"FileDescription\" \"${_DESCRIPTION}\"\nVIAddVersionKey /LANG=0 \"FileVersion\" \"${_VERSION}\"\nVIAddVersionKey /LANG=0 \"LegalCopyright\" \"${_COPYRIGHT}\""];
            });
        });
    };
    NsisComposer.prototype.makeHooks = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = "\nFunction .onInit\n    ";
                        return [4 /*yield*/, this.makeHookOnInit()];
                    case 1: return [2 /*return*/, _a + (_b.sent()) + "\nFunctionEnd"];
                }
            });
        });
    };
    NsisComposer.prototype.makeHookOnInit = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "\n    " + (this.options.languages.length > 1 ? "!insertmacro MUI_LANGDLL_DISPLAY" : '')];
            });
        });
    };
    NsisComposer.prototype.makeInstallSection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = "\n\nSection -Install\n\n    SetShellVarContext current\n    SetOverwrite ifnewer\n    \n    WriteRegStr HKCU \"Software\\${_APPNAME}\" \"InstallDir\" \"$INSTDIR\"\n    \n    # Install - installer Files\n    ";
                        return [4 /*yield*/, this.makeInstallerFiles()];
                    case 1:
                        _b = _a + (_d.sent()) + "\n    \n    # Install - Mui Startmenu Var\n    ";
                        return [4 /*yield*/, this.makeInstallSectionMuiStartmenuVar()];
                    case 2:
                        _c = _b + (_d.sent()) + "\n    \n    # Install - Install Section End\n    ";
                        return [4 /*yield*/, this.makeInstallSectionEnd()];
                    case 3: return [2 /*return*/, _c + (_d.sent()) + "\n\nSectionEnd"];
                }
            });
        });
    };
    NsisComposer.prototype.makeInstallSectionMuiStartmenuVar = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "  \n    !insertmacro MUI_STARTMENU_WRITE_BEGIN \"Application\"\n    \n        CreateDirectory \"$SMPROGRAMS\\$StartMenuFolder\"\n        CreateShortcut \"$SMPROGRAMS\\$StartMenuFolder\\${_APPNAME}.lnk\" \"$INSTDIR\\${_APPNAME}.exe\"\n        CreateShortcut \"$SMPROGRAMS\\$StartMenuFolder\\${_UNINSTNAME}.lnk\" \"$INSTDIR\\${_UNINSTNAME}.exe\"\n    \n    !insertmacro MUI_STARTMENU_WRITE_END\n     "];
            });
        });
    };
    NsisComposer.prototype.makeInstallSectionEnd = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "  \n    WriteUninstaller \"$INSTDIR\\${_UNINSTNAME}.exe\""];
            });
        });
    };
    NsisComposer.prototype.makeUninstallSection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = "\nSection Uninstall\n\n    # FIXME: Remove installed files only.\n    RMDir /r \"$INSTDIR\"\n    \n    # uninstallSectionMui\n    ";
                        return [4 /*yield*/, this.makeUninstallSectionMui()];
                    case 1: return [2 /*return*/, _a + (_b.sent()) + "\n    \n    Delete \"$DESKTOP\\${_APPNAME}.lnk\"\n    \n    DeleteRegKey HKCU \"Software\\${_APPNAME}\"\n\nSectionEnd"];
                }
            });
        });
    };
    NsisComposer.prototype.makeUninstallSectionMui = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "        \n    !insertmacro MUI_STARTMENU_GETFOLDER \"Application\" $StartMenuFolder\n    \n    Delete \"$SMPROGRAMS\\$StartMenuFolder\\${_APPNAME}.lnk\"\n    Delete \"$SMPROGRAMS\\$StartMenuFolder\\${_UNINSTNAME}.lnk\"\n    RMDir \"$SMPROGRAMS\\$StartMenuFolder\"\n        "];
            });
        });
    };
    NsisComposer.prototype.makeInstallerFiles = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, "\n    SetOutPath \"$INSTDIR\"\n    FILE /r .\\*.*"];
            });
        });
    };
    NsisComposer.DIVIDER = '################################################################################';
    NsisComposer.STRINGS = {
        'English': "\nLangString CREATE_DESKTOP_SHORTCUT 1033 \"Create Desktop Shortcut\"\nLangString INSTALLING 1033 \"Installing\"\n        ",
        'SimpChinese': "\nLangString CREATE_DESKTOP_SHORTCUT 2052 \"\u521B\u5EFA\u684C\u9762\u5FEB\u6377\u65B9\u5F0F\"\nLangString INSTALLING 2052 \"\u6B63\u5728\u5B89\u88C5\"\n        ",
        'TradChinese': "\nLangString CREATE_DESKTOP_SHORTCUT 1028 \"\u5EFA\u7ACB\u684C\u9762\u6377\u5F91\"\nLangString INSTALLING 1028 \"\u5B89\u88DD\u4E2D\"\n        ",
    };
    return NsisComposer;
}());
exports.NsisComposer = NsisComposer;
//# sourceMappingURL=NsisComposer.js.map